<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" width="1200">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('FactoryModeling.AutocodeRule.dialogRuleCodeLabel')" prop="ruleCode">
        <el-input
          v-model="formData.ruleCode"
          :placeholder="t('FactoryModeling.AutocodeRule.dialogRuleCodePlaceholder')"
          :disabled="formType == 'update'"
        />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.AutocodeRule.dialogRuleNameLabel')" prop="ruleName">
        <el-input
          v-model="formData.ruleName"
          :placeholder="t('FactoryModeling.AutocodeRule.dialogRuleNamePlaceholder')"
        />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.AutocodeRule.dialogRuleDescLabel')" prop="ruleDesc">
        <el-input
          v-model="formData.ruleDesc"
          :placeholder="t('FactoryModeling.AutocodeRule.dialogRuleDescPlaceholder')"
        />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.AutocodeRule.dialogMaxLengthLabel')" prop="maxLength">
        <el-input
          v-model="formData.maxLength"
          :placeholder="t('FactoryModeling.AutocodeRule.dialogMaxLengthPlaceholder')"
        />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.AutocodeRule.dialogIsPaddedLabel')" prop="isPadded">
        <el-radio-group v-model="formData.isPadded">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.ERP_AUTOCODE_IS_PADDING)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.AutocodeRule.dialogPaddedCharLabel')" prop="paddedChar">
        <el-input
          v-model="formData.paddedChar"
          :placeholder="t('FactoryModeling.AutocodeRule.dialogPaddedCharPlaceholder')"
        />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.AutocodeRule.dialogPaddedMethodLabel')" prop="paddedMethod">
        <el-radio-group v-model="formData.paddedMethod">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.ERP_AUTOCODE_PADDING_TYPE)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.AutocodeRule.dialogRemarkLabel')" prop="remark">
        <el-input
          v-model="formData.remark"
          :placeholder="t('FactoryModeling.AutocodeRule.dialogRemarkPlaceholder')"
          type="textarea"
        />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.AutocodeRule.dialogIsEnableLabel')" prop="isEnable">
        <el-radio-group v-model="formData.isEnable">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <!-- 子表的表单 -->
    <el-tabs v-model="subTabsName">
      <el-tab-pane :label="t('FactoryModeling.AutocodeRule.dialogPartTabLabel')" name="autocodePart">
        <AutocodePartForm ref="autocodePartFormRef" :rule-id="formData.id" />
      </el-tab-pane>
    </el-tabs>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('common.ok') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('common.cancel') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, getBoolDictOptions, DICT_TYPE } from '@/utils/dict'
import { AutocodeRuleApi, AutocodeRuleVO } from '@/api/erp/autocode'
import AutocodePartForm from './components/AutocodePartForm.vue'

/** 编码规则 表单 */
defineOptions({ name: 'AutocodeRuleForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  ruleCode: undefined,
  ruleName: undefined,
  ruleDesc: undefined,
  maxLength: undefined,
  isPadded: undefined,
  paddedChar: undefined,
  paddedMethod: undefined,
  remark: undefined,
  isEnable: undefined
})
const formRules = reactive({
  isEnable: [
    { required: true, message: t('FactoryModeling.AutocodeRule.validatorIsEnableRequired'), trigger: 'blur' }
  ]
})
const formRef = ref() // 表单 Ref

/** 子表的表单 */
const subTabsName = ref('autocodePart')
const autocodePartFormRef = ref()

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await AutocodeRuleApi.getAutocodeRule(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 校验子表单
  try {
    await autocodePartFormRef.value.validate()
  } catch (e) {
    subTabsName.value = 'autocodePart'
    return
  }
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as AutocodeRuleVO
    // 拼接子表的数据
    data.autocodeParts = autocodePartFormRef.value.getData()
    if (formType.value === 'create') {
      await AutocodeRuleApi.createAutocodeRule(data)
      message.success(t('common.createSuccess'))
    } else {
      await AutocodeRuleApi.updateAutocodeRule(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    ruleCode: undefined,
    ruleName: undefined,
    ruleDesc: undefined,
    maxLength: undefined,
    isPadded: undefined,
    paddedChar: undefined,
    paddedMethod: undefined,
    remark: undefined,
    isEnable: true
  }
  formRef.value?.resetFields()
}
</script>
